<?php

namespace Netzmacher\Xblog\Controller;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2019-2021 - Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * Class for rendering media / files in the single view
 *
 * @package TYPO3
 * @subpackage xblog
 * @author Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @internal #i0035
 * @version 0.7.0
 * @since 0.7.0
 */
class MediaController extends AbstractController
{

	/**
	 * @var string path to the language file
	 */
	public $sLanguageFilePath = 'Resources/Private/Language/Media.xlf';

	/**
	 * _viewAssignContent( ) :
	 *
	 * @return void
	 * @access private
	 * @version 0.7.0
	 * @since 0.7.0
	 */
	private function _viewAssignMedia()
	{
		$this->view->assignMultiple(
						array(
								$this->cObjGetSingle( $this->settings[ 'views' ][ 'single' ][ 'register' ] )
								, 'tt_content' => $this->contentObject->data
								, 'content' => $this->cObjGetSingle( $this->settings[ 'views' ][ 'single' ][ 'content' ] )
								, 'debug' => $this->debugMedia()
						)
		);
	}

	/**
	 * listAction( ) : 
	 *
	 * @return void
	 * @access public
	 * @version 0.7.0
	 * @since 0.7.0
	 *
	 */
	public function singleAction()
	{
		$this->initialise();
		$this->_viewAssignMedia();
//		var_dump( __METHOD__, __LINE__, $this->contentObject->data );
		// #i0061, dwildt, 1- //unset( $GLOBALS[ 'TSFE' ]->register );
	}

}
