<?php

namespace Netzmacher\Xblog\Controller;

use Netzmacher\Xblog\Utility\FlexformValueUtility;
use Netzmacher\Xblog\Utility\RegisterUtility;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2018-2021 - Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * Class for rendering records
 *
 * @package TYPO3
 * @subpackage xblog
 * @author Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @version 0.24.4
 * @since 0.0.1
 */
class MiniController extends AbstractController
{

	/**
	 * @var string path to the language file
	 */
	public $sLanguageFilePath = 'Resources/Private/Language/Mini.xlf';

	/**
	 * _flexformValuesToRegister( ) :
	 *
	 * @return void
	 * @access private
	 * @version 0.24.4
	 * @since 0.24.4
	 */
	private function _flexformValuesToRegister()
	{
		$this->_flexformValuesToRegisterPi1();
		$this->_flexformValuesToRegisterPi2();
		$GLOBALS[ 'TSFE' ]->register[ 'pi1__pi_flexform__settings_flexform_pi1_profile_default_topitemonly' ] = $GLOBALS[ 'TSFE' ]->register[ 'pi2__pi_flexform__settings_flexform_pi1_profile_default_topitemonly' ];
		$GLOBALS[ 'TSFE' ]->register[ 'pi1__pi_flexform__settings_flexform_pi1_profile_default_topitemfield' ] = $GLOBALS[ 'TSFE' ]->register[ 'pi2__pi_flexform__settings_flexform_pi1_profile_default_topitemfield' ];
//		var_dump( __METHOD__, __LINE__, $GLOBALS[ 'TSFE' ]->register );
//		die();
	}

	/**
	 * _flexformValuesToRegisterPi1( ) :
	 *
	 * @return void
	 * @access private
	 * @version 0.24.4
	 * @since 0.24.4
	 */
	private function _flexformValuesToRegisterPi1()
	{
		$xmlFlexform = $this->contentObject->data[ 'pi_flexform' ];
		$tab = 'ctrl';
		$field = 'settings.flexform.pi2.ctrl.plugin.single';
		$uid = FlexformValueUtility::getFlexformValue( $xmlFlexform, $tab, $field, __METHOD__, __LINE__ );
		$this->evalTargetXblog( $uid, __METHOD__, __LINE__ );

		if( $uid < 1 )
		{
			$uid = $this->contentObject->data[ 'uid' ];
		}
		$plugin = 'pi1';
		RegisterUtility::setRegister( $uid, $plugin );
	}

	/**
	 * _flexformValuesToRegisterPi12( ) :
	 *
	 * @return void
	 * @access private
	 * @version 0.24.4
	 * @since 0.24.4
	 */
	private function _flexformValuesToRegisterPi2()
	{
		$uid = $this->contentObject->data[ 'uid' ];
		$plugin = 'pi2';
		RegisterUtility::setRegister( $uid, $plugin );
	}

	/**
	 * _viewAssignContent( ) :
	 *
	 * @return void
	 * @access private
	 * @version 0.24.4
	 * @since 0.0.1
	 */
	private function _viewAssignList()
	{
		$this->_flexformValuesToRegister();
		$this->cObjGetSingle( $this->settings[ 'register' ][ ' flexform' ][ 'pi2' ][ 'list' ] );
		$content = $this->cObjGetSingle( $this->settings[ 'CONTENT' ][ 'list' ] );
//		var_dump(__METHOD__, __LINE__, $content);
//		die();
		//var_dump(__METHOD__, __LINE__, $this->settings[ 'register' ][ ' flexform' ][ 'pi2' ][ 'list' ]);
		//var_dump(__METHOD__, __LINE__, $this->cObjGetSingle( $this->settings[ 'views' ][ 'list' ][ 'content' ]));
		$this->view->assignMultiple(
						array(
								'tt_content' => $this->contentObject->data
								, 'content' => $content
								, 'debug' => $this->debugMini()
						)
		);
	}

	/**
	 * listAction( ) : 
	 *
	 * @return void
	 * @access public
	 * @version 0.0.1
	 * @since 0.0.1
	 *
	 */
	public function listAction()
	{
		$this->initialise();
//		var_dump( __METHOD__, __LINE__, $this->settings );
		$this->_viewAssignList();
		// #i0061, dwildt, 1- //unset( $GLOBALS[ 'TSFE' ]->register );
	}

}
