<?php

namespace Netzmacher\Xblog\Controller;

use TYPO3\CMS\Core\Utility\GeneralUtility;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2019-2021 - Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * Class for rendering the search form
 *
 * @package TYPO3
 * @subpackage xblog
 * @author Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @internal #i0038
 * @version 0.20.16
 * @since 0.7.0
 */
class SearchController extends AbstractController
{

	/**
	 * @var string path to the language file
	 */
	public $sLanguageFilePath = 'Resources/Private/Language/Search.xlf';

	/**
	 * _viewAssignList( ) :
	 *
	 * @return void
	 * @access private
	 * @version 0.20.16
	 * @since 0.7.0
	 */
	private function _viewAssignList()
	{
		$this->cObjGetSingle( $this->settings[ 'views' ][ 'list' ][ 'register' ] );

		// #t5531, 200405, dwildt, 3+
		$params = GeneralUtility::_GP( 'tx_xblog_pi8' );
		$sessionData = $this->getSessionData();
		$this->setSessionData( $params, $sessionData );
		$sessionData = $this->getSessionData();

		//var_dump( __METHOD__, __LINE__, $params, $sessionData );

		$xBlogMainRow = $this->getXblogMainRow( 'ctrl', 'settings.flexform.pi8.ctrl.plugin.list' );
		$showUid = $this->getXblogMainShowUid( $xBlogMainRow );

		$this->view->assignMultiple(
						array(
								'tt_content' => $this->contentObject->data
								, 'action' => $this->cObjGetSingle( $this->settings[ 'views' ][ 'list' ][ 'variables' ][ 'action' ] )
								, 'actionIsSingle' => $this->actionIsSingle( $showUid )
								, 'placeholder' => $this->cObjGetSingle( $this->settings[ 'views' ][ 'list' ][ 'variables' ][ 'placeholder' ] )
								, 'plugin' => $this->cObjGetSingle( $this->settings[ 'views' ][ 'list' ][ 'variables' ][ 'plugin' ] )
								, 'sword' => $sessionData[ 'sword' ]
								, 'sessionSet' => $this->cObjGetSingle( $this->settings[ 'views' ][ 'list' ][ 'session' ][ 'setSword' ] )
								, 'xBlogMainPid' => $this->cObjGetSingle( $this->settings[ 'views' ][ 'list' ][ 'variables' ][ 'xBlogMainPid' ] )
								, 'xBlogPi8Handon' => $this->cObjGetSingle( $this->settings[ 'views' ][ 'list' ][ 'variables' ][ 'xBlogPi8Handon' ] )
								, 'debug' => $this->debugSearch()
						)
		);
	}

	/**
	 * listAction( ) : 
	 *
	 * @return void
	 * @access public
	 * @version 0.9.8
	 * @since 0.7.0
	 *
	 */
	public function listAction()
	{
		$this->initialise();
		$this->_viewAssignList();
		//var_dump(__METHOD__, __LINE__, $this->cObjGetSingle( $this->settings[ 'views' ][ 'list']['variables' ][ 'action' ]));
		//die();
		// #i0061, dwildt, 1- //unset( $GLOBALS[ 'TSFE' ]->register );
	}

}
