<?php

namespace Netzmacher\Xblog\Domain\Repository;

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Core\Database\ConnectionPool;

/* * *
 *
 * This file is part of the Xblog extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2019-2021 - Dirk Wildt (Die Netzmacher) <http://wildt@die-netzmacher.de>, Die Netzmacher
 *
 * * */

/**
 * The repository for form rows
 * 
 * @version 0.8.26
 * @since 0.8.26
 */
class FormRepository extends \TYPO3\CMS\Extbase\Persistence\Repository
{

	/**
	 * @param int	$rowUid
	 * @return array
	 * @version 0.8.26
	 * @since 0.8.26
	 * @internal #i0116
	 */
	public function getRowsByXblogUid( $xblogUid ): array
	{
		$rows = [];
		$queryBuilder = GeneralUtility::makeInstance( ConnectionPool::class )->getConnectionForTable( 'tx_xblog_domain_model_form' )->createQueryBuilder();
		$queryBuilder
						->select( '*' )
						->from( 'tx_xblog_domain_model_form' )
						->where(
										$queryBuilder->expr()->eq( 'tt_content', $queryBuilder->createNamedParameter( $xblogUid ) )
						)
						->orderBy( 'sorting' )
		;

		$result = $queryBuilder->execute();

		while( $row = $result->fetch() )
		{
			$rows[] = $row;
		}

		return $rows;
	}

}
