<?php

namespace Netzmacher\Xblog\Domain\Repository;

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Core\Database\ConnectionPool;

/* * *
 *
 * This file is part of the Xblog extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2021 - Dirk Wildt (Die Netzmacher) <http://wildt@die-netzmacher.de>, Die Netzmacher
 *
 * * */

/**
 * The repository for tablelayout rows
 * 
	 * @version	0.30.17
	 * @since		0.30.17
 */
class TablelayoutRepository extends \TYPO3\CMS\Extbase\Persistence\Repository
{

	/**
	 * @param		int			$rowUid
	 * @return	array
	 * @version	0.30.17
	 * @since		0.30.17
	 */
	public function getRowsByXblogUid( $xblogUid ): array
	{
		$rows = [];
		$queryBuilder = GeneralUtility::makeInstance( ConnectionPool::class )->getConnectionForTable( 'tx_xblog_domain_model_tablelayout' )->createQueryBuilder();
		$queryBuilder
						->select( '*' )
						->from( 'tx_xblog_domain_model_tablelayout' )
						->where(
										$queryBuilder->expr()->eq( 'tt_content', $queryBuilder->createNamedParameter( $xblogUid ) )
						)
						->orderBy( 'sorting' )
		;

		$result = $queryBuilder->execute();

		while( $row = $result->fetch() )
		{
			$rows[] = $row;
		}

		return $rows;
	}

}
