<?php

//declare(strict_types = 1);

namespace Netzmacher\Xblog\Flexform\Base\Get;

use Netzmacher\Xblog\Utility\SqlUtility;
use Netzmacher\Xblog\Utility\TcaUtility;
use TYPO3\CMS\Backend\Form\Element\AbstractFormElement;

class XblogTable extends AbstractFormElement
{

	/**
	 * _getInputField
	 *
	 * @return string input field with the vale for the HTML form
	 * @version 0.10.1
	 * @since 0.10.1
	 */
	private function _getInputField( $xBlogTable )
	{
		$inputField = '<input class="form-control" value="' . $xBlogTable . '" disabled>';
		return $inputField;
	}

	/**
	 * _getResultArray
	 *
	 * @return array
	 * @version 0.10.1
	 * @since 0.10.1
	 */
	private function _getResultArray( $xBlogTable )
	{
		$resultArray = $this->initializeResultArray();
		$fieldWizardResult = $this->renderFieldWizard();
		$fieldWizardHtml = $fieldWizardResult[ 'html' ];
		$resultArray = $this->mergeChildReturnIntoExistingResult( $resultArray, $fieldWizardResult, false );

		$mainFieldHtml = ''
						. '<div class="form-control-wrap">'
						. '  <div class="form-wizards-wrap">'
						. '    <div class="form-wizards-element">'
						. '      ' . $this->_getInputField( $xBlogTable )
						. '    </div>'
						. '    <div class="form-wizards-items-bottom">'
						. '      ' . $fieldWizardHtml
						. '    </div>'
						. '  </div>'
						. '</div>'
		;

		$resultArray[ 'html' ] = $mainFieldHtml;

		return $resultArray;
	}

	/**
	 * _getXblogUid()
	 *
	 * @return integer uid of the connected xBlog
	 * @version 0.10.1
	 * @since 0.10.1
	 */
	private function _getXblogUid()
	{
		$parameterXblog = $this->data[ 'parameterArray' ][ 'fieldConf' ][ 'config' ][ 'parameters' ][ 'xblog' ];
		$xBlogUid = $this->data[ 'flexFormRowData' ][ $parameterXblog ][ 'vDEF' ][ 0 ];

		return $xBlogUid;
	}

	/**
	 * _getXblogTable()
	 *
	 * @return string		table which is selected by the xBlogMain plugin
	 * @version 0.10.1
	 * @since 0.10.1
	 */
	private function _getXblogTable( $xBlogUid )
	{
		if( empty( $xBlogUid ) )
		{
			return;
		}
		$xBlogTable = SqlUtility::getXBlogSrceTable( $xBlogUid );
		$xBlogTable = TcaUtility::getCtrlTitle( $xBlogTable );

		return $xBlogTable;
	}

	/**
	 * Render single element
	 *
	 * @return array As defined in initializeResultArray() of AbstractNode
	 * @version 0.10.1
	 * @since 0.10.1
	 */
	public function render()
	{
		$xBlogUid = $this->_getXblogUid();
		$xBlogTable = $this->_getXblogTable( $xBlogUid );
		$resultArray = $this->_getResultArray( $xBlogTable );
		//var_dump( __METHOD__, __LINE__, $this->data[ 'parameterArray' ][ 'fieldConf' ][ 'config' ][ 'parameters' ][ 'xblog' ] );
		//var_dump( __METHOD__, __LINE__, $parameterXblog, $this->data[ 'flexFormRowData' ], array_keys( $this->data ) );
//		var_dump( __METHOD__, __LINE__, $this->data[ 'flexFormRowData' ] );
//		die();
//		var_dump( __METHOD__, __LINE__, $xBlogUid, $fieldWizardResult );
//		die();
//		$result[ 'html' ] = $this->_getPrompt( $prompt );
		return $resultArray;
	}

}
