<?php

//declare(strict_types = 1);

namespace Netzmacher\Xblog\Flexform\Base\Help;

use TYPO3\CMS\Backend\Form\Element\AbstractFormElement;

class Prompt extends AbstractFormElement
{

	/**
	 * Render single element
	 *
	 * @return array As defined in initializeResultArray() of AbstractNode
	 * @version 0.10.1
	 * @since 0.10.1
	 */
	public function render()
	{
		$result = $this->initializeResultArray();
		$result[ 'html' ] = $this->_getPrompt();
		return $result;
	}

	/**
	 * Render single element
	 *
	 * @return array As defined in initializeResultArray() of AbstractNode
	 * @version 0.10.1
	 * @since 0.10.1
	 */
	private function _getPrompt()
	{
		//.callout-default
		//.callout-primary
		//.callout-success
		//.callout-info
		//.callout-warning
		//.callout-danger
		$str_prompt = null;

		$str_prompt = $str_prompt . '
			<div class="callout callout-info">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:default.prompt.help' ) . '
			</div>
      ';

		$str_prompt = $str_prompt . '
			<div class="callout callout-warning">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:default.prompt.cookies' ) . '
			</div>
      ';

		$str_prompt = $str_prompt . '
			<div class="callout callout-default">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:default.prompt.newsletter' ) . '
			</div>
      ';

		$str_prompt = $str_prompt . '
			<div class="callout callout-default">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:default.prompt.suggestion' ) . '
			</div>
      ';

		return $str_prompt;
	}

}
