<?php

//declare(strict_types = 1);

namespace Netzmacher\Xblog\TCA\Form\Filter\Element;

use Netzmacher\Xblog\Utility\TcaUtility;
use TYPO3\CMS\Backend\Form\Element\SelectSingleElement;

class FieldElement extends SelectSingleElement
{

	/**
	 * Render single element
	 *
	 * @return array As defined in initializeResultArray() of AbstractNode
	 * @version 0.8.10
	 * @since 0.8.10
	 */
	public function render()
	{
		// For development only - 1/2
//		$empty = false;
//		if( empty( $this->data[ 'inlineParentUid' ] ) )
//		{
//			$this->data[ 'inlineParentUid' ] = 755;
//			$empty = true;
//		}

		$this->_setItems();
		$this->_setItemFormElValue();

		// For development only - 2/2
//		if( $empty )
//		{
//			var_dump( __METHOD__, __CLASS__, $this->data[ 'parameterArray' ] );
//			die();
//		}
		return parent::render();
	}

	/**
	 * Render items for select options
	 *
	 * @return array items
	 * @access	private
	 * @version 0.9.3
	 * @since 0.8.10
	 */
	private function _getItems()
	{
//			var_dump( __METHOD__, __CLASS__, $this->data['databaseRow']['table'] );
//			die();
		$items = NULL;
		$table = $this->data['databaseRow']['table'];

		if( empty( $table ) )
		{
			return null;
		}

		foreach( (array) $GLOBALS[ 'TCA' ][ $table ][ 'columns' ] as $column => $properties )
		{
			// #t4446, 200117, 1-/+
			//if( isset( $properties[ 'config' ][ 'MM' ] ) )
			if( isset( $properties[ 'config' ][ 'foreign_table' ] ) )
			{
				continue;
			}

			$items[] = [
					TcaUtility::getCtrlTitle( $column )
					, $column
					, TcaUtility::getCtrlIconfile( $column )
			];
		}

		if( empty( $items ) )
		{
			return;
		}

		array_multisort( array_column( $items, 0 ), SORT_ASC, $items );

//			var_dump( __METHOD__, __LINE__, $inlineParentUid, $xBlogSrceTable, $items );
//			die();
		return $items;
	}

	/**
	 * Extends the items array for select options
	 *
	 * @return void
	 * @access	private
	 * @version 0.8.10
	 * @since 0.8.10
	 */
	private function _setItems()
	{
		$items = $this->data[ 'parameterArray' ][ 'fieldConf' ][ 'config' ][ 'items' ];
		$items = array_merge(( array ) $items, ( array ) $this->_getItems());

//			var_dump( __METHOD__, __LINE__, $items );
//			die();
		$this->data[ 'parameterArray' ][ 'fieldConf' ][ 'config' ][ 'items' ] = $items;
	}

	/**
	 * Workaround for itemFormElValue: Move string to array[0]
	 *
	 * @return void
	 * @access	private
	 */
	private function _setItemFormElValue()
	{
		if( empty( $this->data[ 'parameterArray' ][ 'itemFormElValue' ] ) )
		{
			return;
		}

		if( is_array( $this->data[ 'parameterArray' ][ 'itemFormElValue' ] ) )
		{
			return;
		}

		$selectedValue = $this->data[ 'parameterArray' ][ 'itemFormElValue' ];
		unset( $this->data[ 'parameterArray' ][ 'itemFormElValue' ] );
		$this->data[ 'parameterArray' ][ 'itemFormElValue' ][ 0 ] = $selectedValue;
	}

}
