<?php

//declare(strict_types = 1);

namespace Netzmacher\Xblog\TCA\Form\Filter\Element;

use Netzmacher\Xblog\Utility\SqlUtility;
use Netzmacher\Xblog\Utility\TcaUtility;
use TYPO3\CMS\Backend\Form\Element\SelectSingleElement;

class FieldlocaltableElement extends SelectSingleElement
{

	/**
	 * Render single element
	 *
	 * @return array As defined in initializeResultArray() of AbstractNode
	 * @version 0.30.17
	 * @since		0.8.23
	 */
	public function render()
	{
//		var_dump(__METHOD__, __LINE__, $this->data[ 'parameterArray' ]);
//		die();
		// For development only - 1/2
//		$empty = false;
//		if( empty( $this->data[ 'inlineParentUid' ] ) )
//		{
//			$this->data[ 'inlineParentUid' ] = 755;
//			$empty = true;
//		}

		$this->_setItems();
		$this->_setItemFormElValue();

		// For development only - 2/2
//		if( $empty )
//		{
//			var_dump( __METHOD__, __CLASS__, $this->data[ 'parameterArray' ] );
//			die();
//		}
		return parent::render();
	}

	/**
	 * Render items for select options
	 *
	 * @return array items
	 * @access	private
	 * @version 0.30.17
	 * @since		0.8.23
	 */
	private function _getItems()
	{
		$items = NULL;
		$table = $this->_getTable();

		if( empty( $table ) )
		{
			return null;
		}

		foreach( ( array ) $GLOBALS[ 'TCA' ][ $table ][ 'columns' ] as $column => $properties )
		{
			if( $this->_continue( $properties ) )
			{
				continue;
			}

			$items[] = [
					TcaUtility::getCtrlTitle( $column )
					, $column
					, TcaUtility::getCtrlIconfile( $column )
			];
		}

		if( empty( $items ) )
		{
			return;
		}

		array_multisort( array_column( $items, 0 ), SORT_ASC, $items );

		return $items;
	}

	/**
	 * _continue()
	 *
	 * @param		array		$properties
	 * @return	boolean	
	 * @access	private
	 * @version 0.30.17
	 * @since		0.8.23
	 */
	private function _continue( $properties )
	{
		$parameterArray = $this->data[ 'parameterArray' ];
		$displayForeigntables = $parameterArray[ 'fieldConf' ][ 'config' ][ 'parameters' ][ 'displayForeigntables' ];

		if( $displayForeigntables )
		{
			return false;
		}
		if( !isset( $properties[ 'config' ][ 'foreign_table' ] ) )
		{
			return false;
		}
		if( $properties[ 'config' ][ 'foreign_table' ] == 'sys_file_reference' )
		{
			return false;
		}
		return true;
	}

	/**
	 * Get the local table
	 *
	 * @return string
	 * @access	private
	 * @version 0.8.23
	 * @since 0.8.23
	 */
	private function _getTable()
	{
		$parentUid = $this->data[ 'inlineParentUid' ];
//			var_dump( __METHOD__, __LINE__, $this->data);
//			die();

		if( empty( $parentUid ) )
		{
			$parentUid = $this->data[ 'databaseRow' ][ 'tt_content' ];
		}

		if( empty( $parentUid ) )
		{
			$prompt = __METHOD__ . ' (#' . __LINE__ . '): parent uid is empty!';
			die( $prompt );
		}

		$table = SqlUtility::getXBlogSrceTable( $parentUid );

		return $table;
	}

	/**
	 * Extends the items array for select options
	 *
	 * @return void
	 * @access	private
	 * @version 0.8.23
	 * @since 0.8.23
	 */
	private function _setItems()
	{
		$items = $this->data[ 'parameterArray' ][ 'fieldConf' ][ 'config' ][ 'items' ];
		$items = array_merge( ( array ) $items, ( array ) $this->_getItems() );

//			var_dump( __METHOD__, __LINE__, $items );
//			die();
		$this->data[ 'parameterArray' ][ 'fieldConf' ][ 'config' ][ 'items' ] = $items;
	}

	/**
	 * Workaround for itemFormElValue: Move string to array[0]
	 *
	 * @return void
	 * @access	private
	 * @version 0.8.23
	 * @since 0.8.23
	 */
	private function _setItemFormElValue()
	{
		if( empty( $this->data[ 'parameterArray' ][ 'itemFormElValue' ] ) )
		{
			return;
		}

		if( is_array( $this->data[ 'parameterArray' ][ 'itemFormElValue' ] ) )
		{
			return;
		}

		$selectedValue = $this->data[ 'parameterArray' ][ 'itemFormElValue' ];
		unset( $this->data[ 'parameterArray' ][ 'itemFormElValue' ] );
		$this->data[ 'parameterArray' ][ 'itemFormElValue' ][ 0 ] = $selectedValue;
	}

}
