<?php

namespace Netzmacher\Xblog\Userfunc\AndWhere;

use Netzmacher\Xblog\Utility\SqlInjectionUtility;
use Netzmacher\Xblog\Utility\TcaUtility;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2021 - Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * 
 *
 * @author    Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package    TYPO3
 * @subpackage  xblog
 *
 * @version 0.30.7
 * @since 0.30.7
 */
class SwordAndwhereUserfunc
{

	/**
	 * WhereSwordParts() : 
	 *
	 * @param  string		$table		: table 
	 * @param  string		$sword		:	sword
	 * @return string		$andWhere	: SQL query part for an AND WHERE
	 * @version 0.30.7
	 * @since 0.30.7
	 */
	public static function WhereSword( $table, $sword )
	{
		$sword = SqlInjectionUtility::String( $sword );
		$csvSearchfields = TcaUtility::getCtrlSearchfields( $table );


		$searchFieldsArray = explode( ',', $csvSearchfields );
		foreach( ( array ) $searchFieldsArray as $searchField )
		{
			$searchField = trim( $searchField );
			if( empty( $searchField ) )
			{
				continue;
			}
			$queryParts[] = '`' . $table . '`.`' . $searchField . "` LIKE \"%" . $sword . "%\"";
		}

		if( empty( $queryParts ) )
		{
			return;
		}

		$andWhere = ' AND (' . implode( ' OR ', ( array ) $queryParts ) . ')';
		return $andWhere;
	}

}
