<?php

namespace Netzmacher\Xblog\Userfunc;

use Netzmacher\Xblog\Utility\SessionFeUserUtility;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2018-2021 - Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * 
 *
 * @author    Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package    TYPO3
 * @subpackage  xblog
 *
 * @version 0.20.35
 * @since 0.5.2
 */
class ControllingUserfunc extends AbstractUserfunc
{

	/**
	 * @var array current configuration array from TypoScript of the calling userFunc 
	 */
	public $_conf;

	/**
	 * @var string
	 */
	private $_promptParamRemoveShowUidFromSession = ''
					. '<h2>'
					. 'userFunc = Netzmacher\Xblog\Userfunc\ControllingUserfunc->RemoveShowUidFromSession'
					. '</h2>'
					. '<p>'
					. 'Params are:'
					. '</p>'
					. '<ul>'
					. '<li>'
					. 'showUid'
					. '</li>'
					. '<li>'
					. 'devUid (optional)'
					. '</li>'
					. '</ul>'
	;

	/**
	 * RemoveShowUidFromSession():
	 *
	 * @param  string          Empty string (no content to process)
	 * @param  array           TypoScript configuration
	 * @return boolean         
	 * @access public
	 * @version 0.5.2
	 * @since 0.5.2
	 */
	public function RemoveShowUidFromSession( $content, $conf )
	{

//		var_dump( __METHOD__, __LINE__ );
		unset( $content );
		$this->_conf = $conf;

		$this->_promptDevUid();

		switch( true )
		{
			case(!$this->_extManagerEnabledSessionManagement() ):
			case( $this->_unproperParam( 'showUid', $this->_promptParamRemoveShowUidFromSession ) ):
				return;
			default:
			// follow the workflow
		}

		$this->showUid = $this->_cObj( 'showUid' );

		switch( true )
		{
			case(!$this->_pluginMatchs()):
			// #t5442.3, 200704, dwildt, 1-
			//case(!$this->_pluginExclusive()):
			case(!$this->_showuidInSession()):
				return;
			default:
				$this->_removeShowuidFromSession();
				return;
		}
	}

	/**
	 * _removeShowuidFromSession():
	 *
	 * @return void
	 * @access private
	 * @version 0.20.17
	 * @since 0.5.2
	 */
	private function _removeShowuidFromSession()
	{
		$uid = $this->cObj->data[ 'uid' ];

		$arrSessionData = SessionFeUserUtility::Get( 'tx_xblog' );
		unset( $arrSessionData[ $uid ][ $this->showUid ] );
		SessionFeUserUtility::Set( 'tx_xblog', $arrSessionData );

		//var_dump( __METHOD__, __LINE__, 'showuid is removed from sesssion!' );
	}

	/**
	 * _showuidInSession():
	 *
	 * @return boolean         
	 * @access private
	 * @version 0.5.2
	 * @since 0.5.2
	 */
	private function _showuidInSession()
	{
		$uid = $this->cObj->data[ 'uid' ];

		$arrSessionData = SessionFeUserUtility::Get( 'tx_xblog' );
		if( $arrSessionData[ $uid ][ $this->showUid ] )
		{
			return true;
		}

		//var_dump( __METHOD__, __LINE__, 'no showuid in session!' );
		return false;
	}

}
