<?php

namespace Netzmacher\Xblog\Userfunc;

use Netzmacher\Xblog\Userfunc\AbstractUserfunc;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2021 - Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * 
 *
 * @author    Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package    TYPO3
 * @subpackage  xblog
 *
 * @version 0.25.1
 * @since 0.25.1
 */
class MaxUserfunc extends AbstractUserfunc
{

	/**
	 * @var array	typoscript configuration
	 */
	public $_conf;

	/**
	 * @var string
	 */
	private $_debugUid;

	/**
	 * @var string [empty] | first | selected
	 */
	private $_mode;

	/**
	 * @var string current table
	 */
	private $_table;

	/**
	 * @var string list | single
	 */
	private $_view;

	/**
	 * @var integer		uid of the selected record
	 */
	private $_uid;

	/**
	 * Returns a the value for select.max
	 *
	 * @param string $content (empty)
	 * @param array $conf typoscript configuration of current object
	 * 
	 * @return string andWhere statement
	 * @version 0.25.1
	 * @since 0.25.1
	 */
	public function Max( $content, $conf )
	{
		unset( $content );

		$this->_conf = $conf;

		$this->_mode = $this->_cObj( 'mode' );
		$this->_xBlogPi1Max = $this->_cObj( 'xBlogPi1Max' );
		$this->_debugUid = $this->_cObj( 'debugUid' );

		$this->_requirements();

		switch( true )
		{
			case($this->_mode == 'first'):
				return 1;
			default:
				return $this->_xBlogPi1Max;
		}
	}

	/**
	 * _requirements()
	 * 
	 * @return void
	 * @version 0.25.1
	 * @since 0.25.1
	 */
	private function _requirements()
	{
		switch( $this->_mode )
		{
			case(''):
			case( 'first' ):
			case( 'selected' ):
				return;
			default:
				$this->_requirementsDie();
		}
	}

	/**
	 * _requirementsDie()
	 * 
	 * @return void
	 * @version 0.25.1
	 * @since 0.25.1
	 */
	private function _requirementsDie()
	{
		$prompt = ''
						. '<h1>'
						. '  FATAL ERROR'
						. '</h1>'
						. '<h2>'
						. '  Value of mode isn\'t defined'
						. '</h2>'
						. '<p>'
						. '  mode = "' . $this->_mode . '"'
						. '</p>'
						. '<p>'
						. '  Error occurs @<br />'
						. '  PHP: ' . __METHOD__ . '#' . __LINE__ . '<br />'
						. '  TypoScript: ' . $this->_debugUid . '<br />'
						. '</p>'
		;
		die( $prompt );
	}

}
