<?php

namespace Netzmacher\Xblog\Userfunc;

use Netzmacher\Xblog\Userfunc\AbstractUserfunc;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2020-2021 - Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * 
 *
 * @author    Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package    TYPO3
 * @subpackage  xblog
 *
 * @version 0.20.33
 * @since 0.20.33
 * @internal #t4182
 */
class SysCategoryAbstractUserfunc extends AbstractUserfunc
{

	public $_conf;

	/**
	 * Check conditions for a join
	 *
	 * @param array $fields fields of the current SQL row
	 * 
	 * @return boolean
	 * @version 0.20.33
	 * @since 0.20.33
	 */
	protected function _condition( $fields )
	{
		$fieldOperator = $fields[ 'operator' ];
		// #i0131, 200424, dwildt, 1+
		$fieldType = $fields[ 'type' ];
		$foreignUid = $fields[ 'value' ];

		// #i0131, 200424, dwildt, 4+
		if( $fieldType != 'foreigntable' )
		{
			return false;
		}
		
		switch( true )
		{
			case(empty( $fieldType = 'isNull' )):
				return false;
			case($fieldOperator = 'isNull'):
			case($fieldOperator = 'isNotNull'):
				return true;
			case(empty( $foreignUid )):
				return false;
			default:
				return true;
		}
	}

	/**
	 * If $MM_match_table_local is empty, there will be a prompt. Process will die!
	 *
	 * @param string $MM_match_table_local
	 * @param string $localTable
	 * @param string $fieldTable
	 * @param string $method
	 * @param string $line
	 * 
	 * @version 0.20.33
	 * @since 0.20.33
	 */
	protected function _promptMatchTableLocalEmptyDie( $MM_match_table_local, $localTable, $fieldTable, $method, $line )
	{
		if( !empty( $MM_match_table_local ) )
		{
			return;
		}
		$prompt = 'ERROR @ ' . $method . ' (#' . $line . ')<br />' . PHP_EOL
						. '<br />' . PHP_EOL
						. 'THIS IS A TODO FOR THE DEVELOPER!<br />' . PHP_EOL
						. '<br />' . PHP_EOL
						. 'Process isn\'t proper without a MM match table local :(' . PHP_EOL
						. '<br />' . PHP_EOL
						. 'MM_match_table_local: ' . $MM_match_table_local . '<br />' . PHP_EOL
						. 'table: ' . $localTable . '<br />' . PHP_EOL
						. 'column: ' . $fieldTable;
		die( $prompt );
	}

}
