<?php

namespace Netzmacher\Xblog\Utility;

use TYPO3\CMS\Core\Utility\GeneralUtility;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2019-2021 - Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * for the xBlog extension
 *
 * @package TYPO3
 * @subpackage xblog
 * @author Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @version 0.8.26
 * @since 0.8.26
 */
class FlashmessageUtility
{

	/**
	 * getFlexformValue():
	 *
	 * @param string header
	 * @param string text
	 * @param string severity
	 * @param string method
	 * @param integer line
	 * @param boolean process
	 * @return void
	 * @version 0.8.26
	 * @since 0.5.2
	 */
	public static function render( $header, $text, $severity, $method, $line, $process = true )
	{
		if( !$process )
		{
			return;
		}
		switch( $severity )
		{
			case('INFO'):
				$type = \TYPO3\CMS\Core\Messaging\FlashMessage::INFO;
				break;
			case('OK'):
				$type = \TYPO3\CMS\Core\Messaging\FlashMessage::OK;
				break;
			case('WARNING'):
				$type = \TYPO3\CMS\Core\Messaging\FlashMessage::WARNING;
				break;
			case('ERROR'):
				$type = \TYPO3\CMS\Core\Messaging\FlashMessage::ERROR;
				break;
			case('NOTICE'):
			default:
				$type = \TYPO3\CMS\Core\Messaging\FlashMessage::NOTICE;
				break;
		}

		if( is_array( $text ) )
		{
			$text = serialize( $text );
		}

		$text = $text . ' [' . $method . ' #' . $line . ']';
//		$message = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance( \TYPO3\CMS\Core\Messaging\FlashMessage::class
//										, $text
//										, $header
//										, $type
//										, true
//		);
//		$flashMessageService = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance( \TYPO3\CMS\Core\Messaging\FlashMessageService::class );
//		$messageQueue = $flashMessageService->getMessageQueueByIdentifier();
//		$messageQueue->addMessage( $message );

		$flashMessageQueue = GeneralUtility::makeInstance( \TYPO3\CMS\Core\Messaging\FlashMessageService::class )->getMessageQueueByIdentifier();
		$flashMessageQueue->addMessage(
						GeneralUtility::makeInstance(
										\TYPO3\CMS\Core\Messaging\FlashMessage::class
										, $text
										, $header
										, $type
										, true
						)
		);
	}

}
