<?php

namespace Netzmacher\Xblog\Utility;

if( !defined( 'TYPO3_MODE' ) )
{
	die( 'Access denied.' );
}

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2019-2021 -  Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 *
 * @author  Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package TYPO3
 * @subpackage  xBlog
 * @version     0.9.0
 * @since       0.8.5
 */
class FlexformUtility
{
	
	
	/**
	 * ctrlPluginExternalAdditionalparams( ):
	 *
	 * @return  string
	 * @access public
	 * @version 0.9.0
	 * @since 0.9.0
	 */
	public function ctrlPluginExternalAdditionalparams()
	{
		//.callout-default
		//.callout-primary
		//.callout-success
		//.callout-info
		//.callout-warning
		//.callout-danger
		$str_prompt = null;

		$str_prompt = $str_prompt . '
			<div class="callout callout-info">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:sheet_ctrl.plugin.external.help.text' ) . '
			</div>
      ';

		$str_prompt = $str_prompt . '
			<div class="callout callout-default">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:default.prompt.help' ) . '
			</div>
      ';

		return $str_prompt;
	}
/**
	 * defaultHelpPrompt( ):
	 *
	 * @return  string
	 * @access public
	 * @version 0.8.15
	 * @since 0.8.15
	 */
	public function defaultHelpPrompt()
	{
		//.callout-default
		//.callout-primary
		//.callout-success
		//.callout-info
		//.callout-warning
		//.callout-danger
		$str_prompt = null;

		$str_prompt = $str_prompt . '
			<div class="callout callout-info">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:default.prompt.help' ) . '
			</div>
      ';

		$str_prompt = $str_prompt . '
			<div class="callout callout-warning">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:default.prompt.cookies' ) . '
			</div>
      ';

		$str_prompt = $str_prompt . '
			<div class="callout callout-default">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:default.prompt.newsletter' ) . '
			</div>
      ';

		$str_prompt = $str_prompt . '
			<div class="callout callout-default">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:default.prompt.suggestion' ) . '
			</div>
      ';

		return $str_prompt;
	}

	/**
	 * defaultSuggestionPrompt( ):
	 *
	 * @return  string
	 * @access public
	 * @version 0.8.15
	 * @since 0.8.15
	 */
	public function defaultSuggestionPrompt()
	{
		//.callout-default
		//.callout-primary
		//.callout-success
		//.callout-info
		//.callout-warning
		//.callout-danger
		$str_prompt = null;

		$str_prompt = $str_prompt . '
			<div class="callout callout-default">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:default.prompt.suggestion' ) . '
			</div>
      ';

		return $str_prompt;
	}

	/**
	 * sheetImagePrompt( ):
	 *
	 * @return  string
	 * @access public
	 * @version 0.8.15
	 * @since 0.8.5
	 */
	public function sheetImagePrompt()
	{
		//.callout-default
		//.callout-primary
		//.callout-success
		//.callout-info
		//.callout-warning
		//.callout-danger
		$str_prompt = null;

		$str_prompt = $str_prompt . '
			<div class="callout callout-info">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Image.xlf:sheet_image.prompt.content' ) . '
			</div>
      ';

		return $str_prompt;
	}

	/**
	 * sheetSpecialPromptPidForSingleView( ):
	 *
	 * @return  string
	 * @access public
	 * @version 0.8.15
	 * @since 0.8.5
	 */
	public function sheetSpecialPromptPidForSingleView()
	{
		//.callout-default
		//.callout-primary
		//.callout-success
		//.callout-info
		//.callout-warning
		//.callout-danger
		$str_prompt = null;

		$str_prompt = $str_prompt . '
			<div class="callout callout-info">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:sheet_special.promptPidForSingleView.text' ) . '
			</div>
      ';

		return $str_prompt;
	}
	
	/**
	 * sheetTmplPromptExternalTemplate( ):
	 *
	 * @return  string
	 * @access public
	 * @version 0.9.11
	 * @since 0.9.11
	 */
	public function sheetTmplPromptExternalTemplate()
	{
		//.callout-default
		//.callout-primary
		//.callout-success
		//.callout-info
		//.callout-warning
		//.callout-danger
		$str_prompt = null;

		$str_prompt = $str_prompt . '
			<div class="callout callout-warning">
				' . $GLOBALS[ 'LANG' ]->sL( 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Main.xlf:sheet_tmpl.promptExternalTemplate.text' ) . '
			</div>
      ';

		return $str_prompt;
	}	

}
