<?php

namespace Netzmacher\Xblog\Utility;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2019-2021 -  Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 *
 * @author  Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package TYPO3
 * @subpackage  xBlog
 * @version     0.9.5
 * @since       0.9.5
 */
class LanguageUtility
{

	/**
	 * Get a localised label in backend or frontend context
	 *
	 * @param string	label		For example: LLL:EXT:lang/Resources/Private/Language/locallang_general.xlf:LGL.author
	 * @return string	label
	 * @access public
	 * @version 0.9.5
	 * @since 0.9.5
	 */
	public static function getLabelInContextofBEOrFe( $label )
	{
		switch( true )
		{
			case($GLOBALS[ 'BE_USER' ]):
				$label = $GLOBALS[ 'LANG' ]->sL( $label );
				break;
			case(!$GLOBALS[ 'BE_USER' ]):
			default:
				$tsConf[ '_typoScriptNodeValue' ] = 'TEXT';
				$tsConf[ 'data' ] = $label;
				$label = TypoScriptUtility::cObjGetSingle( $tsConf );
				break;
		}
		return $label;
	}

}
