<?php

namespace Netzmacher\Xblog\Utility;
use TYPO3\CMS\Core\Utility\GeneralUtility;

if (!defined('TYPO3_MODE'))
{
  die('Access denied.');
}

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2021 -  Dirk Wildt <http://wildt.at.die-netzmacher.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 *
 * @author      Dirk Wildt <http://wildt.at.die-netzmacher.de>
 * @package     TYPO3
 * @subpackage  xBlog
 * @version     0.31.5
 * @since       0.31.5
 */
class UriUtility
{

  /**
   * GetXblogPointer( ):
   *
   * @return  integer
   * @version     0.31.5
   * @since       0.31.5
   */
  static public function GetXblogPointer()
  {
    $pointer = self::_getArgument('pointer');
    return $pointer;
  }

  /**
   * _getArguments( ):
   *
   * @param   string $param   Parameter
   * @param   string $plugin  Plugin
   * @return  string
   * @version 0.31.5
   * @since   0.31.5
   */
  static private function _getArgument($param, $plugin = 'tx_xblog_pi1')
  {
    $params = self::_getArguments($plugin);
    return $params[$param];
  }

  /**
   * _getArguments( ):
   *
   * @param   string $plugin Plugin
   * @return  string
   * @version 0.31.5
   * @since   0.31.5
   */
  static private function _getArguments($plugin = 'tx_xblog_pi1')
  {
    $params = GeneralUtility::_GP($plugin);
    return $params;
  }

}
