<?php

namespace Netzmacher\Xblog\ViewHelpers;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2019-2021 - Dirk Wildt <http://wildt.at.die-netzmacher.de/>
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * @author Dirk Wildt <http://wildt.at.die-netzmacher.de/>
 * 
 * @version 0.9.5
 * @since 0.9.5
 */
class IsarrayViewHelper extends \TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper
{

	/**
	 * @return void
	 * 
	 * @version 0.9.5
	 * @since 0.9.5
	 */
	public function initializeArguments()
	{
		parent::initializeArguments();
		$this->registerArgument( 'myvar', 'string', 'test', true );
	}

	/**
	 * @return bool
	 * 
	 * @version 0.9.5
	 * @since 0.9.5
	 */
	public function render()
	{
		$arg = $this->arguments[ 'myvar' ];
		$argType = gettype( $arg );

		if( $argType == 'array' )
		{
			return 1;		//match
		}
		else
		{
			return 0;		//No match
		} 
	}

}
