<?php

namespace Netzmacher\Xblog\ViewHelpers\Publish;

use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2021 - Dirk Wildt <http://wildt.at.die-netzmacher.de/>
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * @author Dirk Wildt <http://wildt.at.die-netzmacher.de/>
 * 
 * @version 0.31.0
 * @since 0.31.0
 */
class AddViewHelper extends AbstractViewHelper
{

//	/**
//	 * @return void
//	 * 
//	 * @version 0.31.0
//	 * @since 0.31.0
//	 */
//	public function initializeArguments()
//	{
////     * @param string $name Name of the argument
////     * @param string $type Type of the argument
////     * @param string $description Description of the argument
////     * @param boolean $required If TRUE, argument is required. Defaults to FALSE.
////     * @param mixed $defaultValue Default value of argument
//		$this->registerArgument( 'extActionList', 'string', 'list view action', true );
//		$this->registerArgument( 'extActionSingle', 'string', 'single view action', true );
//		$this->registerArgument( 'extController', 'string', 'current table', true );
//		$this->registerArgument( 'extParam', 'string', 'extension parameter like tx_xblog_pi1', true );
//		$this->registerArgument( 'extShowUid', 'string', 'label of the showUid', true );
//		$this->registerArgument( 'table', 'string', 'current table', true );
//		$this->registerArgument( 'viewList', 'integer', 'page id of the list view', true );
//		$this->registerArgument( 'viewPublish', 'integer', 'page id of the view with the publish plugin', true );
//		$this->registerArgument( 'viewSingle', 'integer', 'page id auf the single view', true );
//	}

	/**
	 * renderStatic():	returns true, if
	 * 									* a frontend user is logged on
	 * 									and if if in the plugin/flexform
	 * 									* is enabled: advanced publish
	 * 									* is set: the page id for page with the plugin publish_pi1
	 * 
	 * @param		array			$arguments
	 * @param		\Closure	$renderChildrenClosure
	 * @param		RenderingContextInterface $renderingContext
	 * @return	boolean
	 * @version	0.31.0
	 * @since		0.31.0
	 */
	public static function renderStatic( array $arguments, \Closure $renderChildrenClosure, RenderingContextInterface $renderingContext )
	{
		unset( $renderChildrenClosure );
		unset( $renderingContext );

		//var_dump(__METHOD__, __LINE__, $arguments);

		switch( true )
		{
			case(!self::issetAdvancedPublish()):
			case(!self::issetFeUser()):
			case(!self::issetPublishPid()):
			case(!self::issetStoragePid()):
				return false;
			default:
				return true;
		}
	}

}
