<?php

namespace Netzmacher\Xblog\ViewHelpers;

/* * *************************************************************
 *  Copyright notice
 *
 *  (c) 2020-2021 - Dirk Wildt <http://wildt.at.die-netzmacher.de/>
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 * ************************************************************* */

/**
 * @author Dirk Wildt <http://wildt.at.die-netzmacher.de/>
 * 
 * @version 0.10.7
 * @since 0.10.7
 */
class UrlViewHelper extends \TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper
{

	/**
	 * @return bool
	 * 
	 * @version 0.10.7
	 * @since 0.10.7
	 */
	public function render()
	{
		$url = '://' . filter_input( INPUT_SERVER, 'HTTP_HOST' ) . filter_input( INPUT_SERVER, 'REQUEST_URI' );

		$port = filter_input( INPUT_SERVER, 'SERVER_PORT' );
		switch( true )
		{
			case($port == '80'):
				$url = 'http' . $url;
				break;
			case($port == '443'):
			default:
				$url = 'https' . $url;
				break;
		}

		//var_dump( __METHOD__, __LINE__, $url );
		return $url;
	}

}
