<?php

use Netzmacher\Xblog\Domain\Model\Element;
use Netzmacher\Xblog\Utility\ConfigurationUtility;

$elementTca = [
		'ctrl' => [
				'title' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME,
				'label' => 'title',
				'label_alt' => 'type,source',
				'label_alt_force' => true,
				'tstamp' => 'tstamp',
				'crdate' => 'crdate',
				'cruser_id' => 'cruser_id',
				'dividers2tabs' => true,
				'versioningWS' => true,
				'origUid' => 't3_origuid',
				'languageField' => 'sys_language_uid',
				'transOrigPointerField' => 'l10n_parent',
				'transOrigDiffSourceField' => 'l10n_diffsource',
				// #t4183, 191005, dwildt, 1-/+
//'default_sortby' => 'ORDER BY title ASC',
				'sortby' => 'sorting',
				'delete' => 'deleted',
				'enablecolumns' => [
						'disabled' => 'hidden',
				],
				'iconfile' => ConfigurationUtility::getIconPath( Element::TABLE_NAME . '.svg' ),
				'type' => 'type',
				'typeicon_column' => 'type',
				'typeicon_classes' => \Netzmacher\Xblog\TCA\Ctrl\Icons::TypeIconClasses( Element::TABLE_NAME ),
				'searchFields' => ''
				. 'title,'
		,
		],
		'interface' => [
// #v0466, 210105, dwildt, -
//				'showRecordFieldList' => ''
//				. 'title,'
//		,
		],
		'palettes' => [
				'checkbox' => [
						'showitem' => ''
						. 'type,name,title,columnsclass,'
				],
				'default' => [
						'showitem' => ''
						. 'type,name,title,columnsclass,'
				],
				'defaultWoName' => [
						'showitem' => ''
						. 'type,title,columnsclass,'
				],
				'hidden' => [
						'showitem' => ''
						. 'type,name,title,value,'
				],
				'period' => [
						'showitem' => ''
						. 'period,periodbegin,perioditems,'
				],
				'radio' => [
						'showitem' => ''
						. 'type,name,title,columnsclass,'
				],
				'select' => [
						'showitem' => ''
						. 'type,name,title,columnsclass,'
				],
				'selectsetup' => [
						'showitem' => ''
						. 'required,,columnsadditionalclass,--linebreak--,'
						. 'displaytitle,displaytitlefirstoption,sortbyoptionlabel,'
				],
				'setup' => [
						'showitem' => ''
						. 'displaytitle,columnsadditionalclass,'
				],
				'setupclass' => [
						'showitem' => ''
						. 'columnsadditionalclass,'
				],
				'sourcecheckbox' => [
						'showitem' => ''
						. 'source,field,table,checkbox,'
				],
				'sourceradio' => [
						'showitem' => ''
						. 'source,field,table,radio,'
				],
				'sourceselect' => [
						'showitem' => ''
						. 'source,field,table,select,'
				],
				'sword' => [
						'showitem' => ''
						. 'type,name,title,columnsclass,'
				],
				'text' => [
						'showitem' => ''
						. 'type,name,title,columnsclass,'
				],
				'textsetup' => [
						'showitem' => ''
						. 'required,displaytitle,placeholder,columnsadditionalclass,'
				],
		],
		'types' => [
				// 0: same as text
				'0' => [
						'showitem' => ''
						. 'hidden,'
						. 'title,'
						. 'tx_xblog_domain_model_form,'
						. 'type,'
				,
				],
				'button' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.default;defaultWoName,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.button,'
						. 'button,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.setup,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.setup;setupclass,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.access,'
						. '  hidden,'
//						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.language,'
//						. '  sys_language_uid, l10n_parent, l10n_diffsource,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.extended,'
						. '  tx_xblog_domain_model_form,'
				,
				],
				'checkbox' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.checkbox;checkbox,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.source,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.source;sourcecheckbox,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.setup,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.setup;setup,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.access,'
						. '  hidden,'
//						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.language,'
//						. '  sys_language_uid, l10n_parent, l10n_diffsource,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.extended,'
						. '  tx_xblog_domain_model_form,'
				,
				],
				'hidden' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.hidden;hidden,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.access,'
						. '  hidden,'
//						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.language,'
//						. '  sys_language_uid, l10n_parent, l10n_diffsource,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.extended,'
						. '  tx_xblog_domain_model_form,'
				,
				],
				'placeholder' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.default;defaultWoName,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.setup,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.setup;setupclass,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.access,'
						. '  hidden,'
//						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.language,'
//						. '  sys_language_uid, l10n_parent, l10n_diffsource,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.extended,'
						. '  tx_xblog_domain_model_form,'
				,
				],
				'radio' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.radio;radio,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.source,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.source;sourceradio,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.setup,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.setup;setup,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.access,'
						. '  hidden,'
//						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.language,'
//						. '  sys_language_uid, l10n_parent, l10n_diffsource,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.extended,'
						. '  tx_xblog_domain_model_form,'
				,
				],
				'select' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.select;select,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.source,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.source;sourceselect,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.setup,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.setup;selectsetup,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.access,'
						. '  hidden,'
//						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.language,'
//						. '  sys_language_uid, l10n_parent, l10n_diffsource,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.extended,'
						. '  tx_xblog_domain_model_form,'
				,
				],
				'selectperiod' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.select;select,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.source,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.source;sourceselect,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.setup,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.setup;selectsetup,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.period;period,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.access,'
						. '  hidden,'
//						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.language,'
//						. '  sys_language_uid, l10n_parent, l10n_diffsource,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.extended,'
						. '  tx_xblog_domain_model_form,'
				,
				],
				'sword' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.sword;sword,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.setup,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.setup;textsetup,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.access,'
						. '  hidden,'
//						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.language,'
//						. '  sys_language_uid, l10n_parent, l10n_diffsource,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.extended,'
						. '  tx_xblog_domain_model_form,'
				,
				],
				'text' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.text;text,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.setup,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . 'palette.setup;textsetup,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.access,'
						. '  hidden,'
//						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.language,'
//						. '  sys_language_uid, l10n_parent, l10n_diffsource,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.extended,'
						. '  tx_xblog_domain_model_form,'
				,
				],
		],
		'columns' => [
				'sys_language_uid' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.language',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'foreign_table' => 'sys_language',
								'foreign_table_where' => 'ORDER BY sys_language.title',
								'default' => 0,
								'items' => [
										[ 'LLL:EXT:lang/Resources/Private/Language/locallang_general.xml:LGL.allLanguages', -1 ],
										[ 'LLL:EXT:lang/Resources/Private/Language/locallang_general.xml:LGL.default_value', 0 ]
								],
						],
				],
// #v0466, 210105, dwildt, -
//				'l10n_parent' => [
//						'displayCond' => 'FIELD:sys_language_uid:>:0',
//						'exclude' => 1,
//						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.l18n_parent',
//						'config' => [
//								'type' => 'select',
//								'renderType' => 'selectSingle',
//								'items' => [
//										[ '', 0 ],
//								],
//								'foreign_table' => Element::TABLE_NAME,
//								'foreign_table_where' => 'AND ' . Element::TABLE_NAME . '.pid=###CURRENT_PID### AND ' . Element::TABLE_NAME . '.sys_language_uid IN (-1,0)',
//								'default' => 0
//						],
//				],
//				'l10n_diffsource' => [
//						'config' => [
//								'type' => 'passthrough',
//						],
//				],
				't3ver_label' => [
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.versionLabel',
						'config' => [
								'type' => 'input',
								'size' => 30,
								'max' => 255,
						]
				],
				'button' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.button',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
//										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.button.cancel', 'cancel' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.button.send', 'send' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.button.magnifier', 'magnifier' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.button.reset', 'reset' ],
								],
								'default' => 'send',
						],
				],
				'checkbox' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.checkbox',
						'displayCond' => 'FIELD:source:=:static',
						'config' => [
								'type' => 'text',
								'cols' => '30',
								'rows' => '5',
								'default' => 'small|s' . PHP_EOL . 'medium|m' . PHP_EOL . 'large|l|*' . PHP_EOL . 'extrem|xl',
								'eval' => 'trim,required',
						],
				],
				'columnsclass' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.columnsclass',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.columnsclass.025', '25' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.columnsclass.033', '33' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.columnsclass.050', '50' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.columnsclass.066', '66' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.columnsclass.075', '75' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.columnsclass.100', '1' ],
								],
								'default' => '1',
						],
				],
				'columnsadditionalclass' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.columnsadditionalclass',
						'config' => [
								'type' => 'input',
								'size' => 30,
								'eval' => 'trim',
						],
				],
				'displaytitle' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.displaytitle',
						'config' => [
								'type' => 'check',
								'default' => '1',
						],
				],
				'displaytitlefirstoption' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.displaytitlefirstoption',
						'config' => [
								'type' => 'check',
								'default' => '1',
						],
				],
				'field' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.field',
						'displayCond' => 'FIELD:source:=:localtable',
						'config' => [
								'eval' => 'required',
								'items' => [
										'0' => [
												'0' => '',
												'1' => '',
												'2' => '',
										],
								],
								'type' => 'user',
								'multiple' => 0,
								'renderType' => 'FormFieldElement',
						],
				],
				'hidden' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.hidden',
						'config' => [
								'type' => 'check',
						],
				],
				'name' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.name',
						'config' => [
								'type' => 'input',
								'readOnly' => 1,
								'size' => 30,
						],
				],
				'orientation' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.orientation',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.orientation.landscape', 'landscape' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.orientation.portrait', 'portrait' ],
								],
								'default' => 'landscape'
						],
				],
				'period' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.period',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
//										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.period.hour', 'hour' ],
//										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.period.day', 'day' ],
//										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.period.week', 'week' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.period.month', 'month' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.period.year', 'year' ],
								],
								'default' => 'year'
						],
				],
				'periodbegin' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.yearminus05', 'yearminus05' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.yearminus04', 'yearminus04' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.yearminus03', 'yearminus03' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.yearminus02', 'yearminus02' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.yearminus01', 'yearminus01' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.year', 'year' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.monthminus01', 'monthminus01' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.month', 'month' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.today', 'today' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.now', 'now' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.monthplus01', 'monthplus01' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.yearplus01', 'yearplus01' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.yearplus02', 'yearplus02' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.yearplus03', 'yearplus03' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.yearplus04', 'yearplus04' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.periodbegin.yearplus05', 'yearplus05' ],
								],
								'default' => 'year'
						],
				],
				'perioditems' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.perioditems',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
										[ '1', 1 ],
										[ '2', 2 ],
										[ '3', 3 ],
										[ '4', 4 ],
										[ '5', 5 ],
										[ '6', 6 ],
										[ '7', 7 ],
										[ '8', 8 ],
										[ '9', 9 ],
										[ '10', 10 ],
								],
								'default' => 10
						],
				],
				'placeholder' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.placeholder',
						'config' => [
								'type' => 'input',
								'size' => 30,
								'default' => 'Search Word',
						],
				],
				'radio' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.radio',
						'displayCond' => 'FIELD:source:=:static',
						'config' => [
								'type' => 'text',
								'cols' => '30',
								'rows' => '5',
								'default' => 'Mr.|m|*' . PHP_EOL . 'Mrs.|w|',
								'eval' => 'trim,required',
						],
				],
				'required' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.required',
						'config' => [
								'type' => 'check',
						],
				],
				'select' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.select',
						'displayCond' => 'FIELD:source:=:static',
						'config' => [
								'type' => 'text',
								'cols' => '30',
								'rows' => '5',
								'default' => 'blue|b' . PHP_EOL . 'green|g|*' . PHP_EOL . 'yellow' . PHP_EOL . 'orange|orange' . PHP_EOL . 'red|r',
								'eval' => 'trim,required',
						],
				],
				'sortbyoptionlabel' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.sortbyoptionlabel',
						'config' => [
								'type' => 'check',
								'default' => 1,
						],
				],
				'source' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.source',
						'onChange' => 'reload',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
// :TODO: todo-form, 200112, dwildt: static must be assign to a table.field. 
//										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.source.static', 'static' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.source.localtable', 'localtable' ],
										[ 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.source.foreigntable', 'foreigntable' ],
								],
//								'default' => 'static'
								'default' => 'foreigntable'
						],
				],
				'table' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.table',
						'displayCond' => 'FIELD:source:=:foreigntable',
						'config' => [
								'eval' => 'required',
								'items' => [
										'0' => [
												'0' => '',
												'1' => '',
												'2' => '',
										],
								],
								//'itemsProcFunc' => 'Netzmacher\Xblog\TCA\Columns\Config\ItemsProcFunc->Table',
								'type' => 'user',
								'multiple' => 0,
								'renderType' => 'FormTableElement',
						],
				],
				'title' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.title',
						'config' => [
								'type' => 'input',
								'size' => 30,
								'eval' => 'trim,required',
						],
				],
				'tx_xblog_domain_model_form' => [
						'exclude' => true,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.tx_xblog_domain_model_form',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'foreign_table' => 'tx_xblog_domain_model_form',
								'items' => [
										[ '', 0 ],
								],
								'minitems' => 0,
								'maxitems' => 1,
						//'readOnly' => 1,
						],
				],
				'type' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.type',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
// :TODO: todo-form, 200112, dwildt: static must be assign to a table.field. 
//										'hidden' => [
//												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.type.hidden',
//												'1' => 'hidden',
//												'2' => 'EXT:xblog/Resources/Public/Icons/Element/default.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
//										],
										'checkbox' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.type.checkbox',
												'1' => 'checkbox',
												'2' => 'EXT:xblog/Resources/Public/Icons/Element/default.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
										],
										'radio' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.type.radio',
												'1' => 'radio',
												'2' => 'EXT:xblog/Resources/Public/Icons/Element/default.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
										],
										'select' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.type.select',
												'1' => 'select',
												'2' => 'EXT:xblog/Resources/Public/Icons/Element/default.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
										],
										'sword' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.type.sword',
												'1' => 'sword',
												'2' => 'EXT:xblog/Resources/Public/Icons/Element/default.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
										],
// :TODO: todo-form, 200112, dwildt: static must be assign to a table.field. 
//										'text' => [
//												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.type.text',
//												'1' => 'text',
//												'2' => 'EXT:xblog/Resources/Public/Icons/Element/default.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
//										],
										'placeholder' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.type.placeholder',
												'1' => 'placeholder',
												'2' => 'EXT:xblog/Resources/Public/Icons/Element/default.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
										],
										'button' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.type.button',
												'1' => 'button',
												'2' => 'EXT:xblog/Resources/Public/Icons/Element/default.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
										],
								],
								'default' => 'sword',
						],
				],
				'value' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Element::TABLE_NAME . '.value',
						'config' => [
								'type' => 'input',
								'size' => 30,
								'eval' => 'trim,required',
						],
				],
		],
];

return $elementTca;
