<?php

use Netzmacher\Xblog\Domain\Model\Filter;
use Netzmacher\Xblog\Utility\ConfigurationUtility;

$filterTca = [
		'ctrl' => [
				'title' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME,
				'label' => 'title',
				'tstamp' => 'tstamp',
				'crdate' => 'crdate',
				'cruser_id' => 'cruser_id',
				'dividers2tabs' => true,
				'versioningWS' => true,
				'origUid' => 't3_origuid',
				'languageField' => 'sys_language_uid',
				'transOrigPointerField' => 'l10n_parent',
				'transOrigDiffSourceField' => 'l10n_diffsource',
				'sortby' => 'sorting',
				'delete' => 'deleted',
				'enablecolumns' => [
						'disabled' => 'hidden',
				],
				'iconfile' => ConfigurationUtility::getIconPath( Filter::TABLE_NAME . '.svg' ),
				'type' => 'type',
				'typeicon_column' => 'type',
				'typeicon_classes' => \Netzmacher\Xblog\TCA\Ctrl\Icons::TypeIconClasses( Filter::TABLE_NAME ),
				'searchFields' => ''
				. 'andor,table,field,operator,pattern,suggestion,suggestions,'
				,
		],
		'palettes' => [
				'foreigntable' => [
						'showitem' => ''
						. 'andor,table,field,expertsql,formula,operator,pattern,suggestion,suggestions,value'
				],
				'localtable' => [
						'showitem' => ''
						. 'andor,fieldlocaltable,expertsql,formula,operator,pattern,suggestion,suggestions,value'
				],
				'type' => [
						'showitem' => ''
						. 'type,assistent'
				],
		],
		'types' => [
				'localtable' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:palette.type;type,'
						. 'title,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:palette.localtable;localtable,'
				],
				'foreigntable' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:palette.type;type,'
						. 'title,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:palette.foreigntable;foreigntable,'
				],
				// Fallback (same as foreigntable)
				'0' => [
						'showitem' => ''
						. 'type,'
						. 'title,'
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:palette.statement;statement,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:tabs.access,'
						. '  sys_language_uid, l10n_parent, l10n_diffsource, hidden'
				],
		],
		'columns' => [
				'sys_language_uid' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.language',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'foreign_table' => 'sys_language',
								'foreign_table_where' => 'ORDER BY sys_language.title',
								'default' => 0,
								'items' => [
										[ 'LLL:EXT:lang/Resources/Private/Language/locallang_general.xml:LGL.allLanguages', -1 ],
										[ 'LLL:EXT:lang/Resources/Private/Language/locallang_general.xml:LGL.default_value', 0 ]
								],
						],
				],
				't3ver_label' => [
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.versionLabel',
						'config' => [
								'type' => 'input',
								'size' => 30,
								'max' => 255,
						]
				],
				'hidden' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.hidden',
						'config' => [
								'type' => 'check',
						],
				],
				'andor' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.andor',
						'onChange' => 'reload',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
//										[ '', 'AND' ],
										[ 'AND', 'AND' ],
										[ 'AND (', 'AND (' ],
										[ ') AND (', ') AND (' ],
										[ ') AND ', ') AND' ],
										[ 'OR', 'OR' ],
										[ 'OR (', 'OR (' ],
										[ ') OR (', ') OR (' ],
										[ ') OR ', ') OR' ],
										[ ')', ')' ],
								],
								'default' => 'AND',
								'multiple' => 0,
								'size' => 1,
						],
				],
				'assistent' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.assistent',
						'onChange' => 'reload',
						'config' => [
								'eval' => 'required',
								'itemsProcFunc' => 'Netzmacher\Xblog\TCA\Columns\Config\ItemsProcFunc->Assistent',
								'type' => 'select',
								'renderType' => 'selectSingle',
								'size' => 1,
						],
				],
				'expertsql' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.expertsql',
						'displayCond' => [
								'AND' => [
										'FIELD:andor:!=:)',
										'FIELD:assistent:=:expert',
								],
						],
						'config' => [
								'type' => 'input',
								'size' => 30,
								'default' => 'field operator value',
								'eval' => 'trim,required',
						],
				],
				'field' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.field',
						'displayCond' => [
								'AND' => [
										'FIELD:andor:!=:)',
										'FIELD:assistent:IN:default,formula',
										'FIELD:table:REQ:true',
								],
						],
						'config' => [
								'eval' => 'required',
								'items' => [
										'0' => [
												'0' => '',
												'1' => '',
												'2' => '',
										],
								],
								'type' => 'user',
								'multiple' => 0,
								'renderType' => 'FilterFieldElement',
						],
				],
				'fieldlocaltable' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.field',
						'displayCond' => [
								'AND' => [
										'FIELD:andor:!=:)',
										'FIELD:assistent:IN:default,formula',
								],
						],
						'config' => [
								'eval' => 'required',
								'items' => [
										'0' => [
												'0' => '',
												'1' => '',
												'2' => '',
										],
								],
								'type' => 'user',
								'multiple' => 0,
								'renderType' => 'FilterFieldlocaltableElement',
								'parameters' => [
										'displayForeigntables' => 1,
								],
						],
				],
				'formula' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.formula',
						'displayCond' => [
								'AND' => [
										'FIELD:andor:!=:)',
										'FIELD:assistent:=:formula',
								],
						],
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
										[
												'',
												''
										],
										[
												'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.formula.uptodate',
												'>= UNIX_TIMESTAMP()'
										],
										[
												'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.formula.expired',
												'<= UNIX_TIMESTAMP()'
										],
								],
								'eval' => 'required',
								'multiple' => 0,
								'size' => 1,
						],
				],
				'operator' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.operator',
						'onChange' => 'reload',
						'displayCond' => [
								'AND' => [
										'FIELD:andor:!=:)',
										'FIELD:assistent:IN:default,suggestion',
								],
						],
						'config' => [
								'default' => 'eq',
								'eval' => 'required',
								'itemsProcFunc' => 'Netzmacher\Xblog\TCA\Columns\Config\ItemsProcFunc->Operator',
								'renderType' => 'selectSingle',
								'size' => 1,
								'type' => 'select',
						],
				],
				'pattern' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.pattern',
						'displayCond' => [
								'AND' => [
										'FIELD:andor:!=:)',
										'FIELD:operator:IN:like,notLike',
										'FIELD:assistent:IN:default,suggestion',
								],
						],
						'config' => [
								'type' => 'input',
								'size' => 30,
								'default' => '%search word%',
								'eval' => 'trim,required',
						],
				],
				'suggestion' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.suggestion',
						'displayCond' => [
								'AND' => [
										'FIELD:andor:!=:)',
										'FIELD:operator:IN:eq,in,neq,lt,lte,gt,gte,notIn',
										'FIELD:assistent:=:suggestion',
								],
						],
						'config' => [
								'eval' => 'required',
								'items' => [
										'0' => [
												'0' => '',
												'1' => '',
												'2' => '',
										],
								],
								'itemsProcFunc' => 'Netzmacher\Xblog\TCA\Columns\Config\ItemsProcFunc->Suggestions',
								'type' => 'select',
								'multiple' => 0,
								'renderType' => 'selectSingle',
						],
				],
				'suggestions' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.suggestions',
						'displayCond' => [
								'AND' => [
										'FIELD:andor:!=:)',
										'FIELD:operator:IN:in,notIn',
										'FIELD:assistent:=:suggestion',
								],
						],
						'config' => [
								'autoSizeMax' => 10,
								'items' => [
										'0' => [
												'0' => '',
												'1' => '',
												'2' => '',
										],
								],
								'itemsProcFunc' => 'Netzmacher\Xblog\TCA\Columns\Config\ItemsProcFunc->Suggestions',
								'maxitems' => 99,
								'renderType' => 'selectSingleBox',
								'size' => 2,
								'type' => 'select',
						],
				],
				'table' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.table',
						'displayCond' => [
								'AND' => [
										'FIELD:andor:!=:)',
										'FIELD:type:=:foreigntable',
								],
						],
						'onChange' => 'reload',
						'config' => [
								'items' => [
										'0' => [
												'0' => '',
												'1' => '',
												'2' => '',
										],
								],
								'type' => 'user',
								'multiple' => 0,
								'renderType' => 'FilterTableElement',
						],
				],
				'title' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.title',
						'config' => [
								'type' => 'input',
								'size' => 30,
								'default' => 'AND table.uid = value',
								'eval' => 'trim,required',
						],
				],
				'type' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.type',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
										'localtable' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:type.localtable',
												'1' => 'localtable',
												'2' => 'EXT:xblog/Resources/Public/Icons/Type/localtable.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
										],
										'foreigntable' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:type.foreigntable',
												'1' => 'foreigntable',
												'2' => 'EXT:xblog/Resources/Public/Icons/Type/foreigntable.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
										],
								],
								'default' => 'foreigntable',
						],
				],
				'value' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Filter::TABLE_NAME . '.value',
						'displayCond' => [
								'AND' => [
										'FIELD:andor:!=:)',
										'FIELD:assistent:=:default',
										'FIELD:operator:IN:eq,in,neq,lt,lte,gt,gte,notIn',
								],
						],
						'config' => [
								'eval' => 'trim,required',
								'placeholder' => 'my title',
								'size' => 30,
								'type' => 'input',
						],
				],
		]
];

return $filterTca;