<?php

use Netzmacher\Xblog\Domain\Model\Form;
use Netzmacher\Xblog\Utility\ConfigurationUtility;

$formTca = [
		'ctrl' => [
				'title' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Form::TABLE_NAME,
				'label' => 'title',
				'tstamp' => 'tstamp',
				'crdate' => 'crdate',
				'cruser_id' => 'cruser_id',
				'dividers2tabs' => true,
				'versioningWS' => true,
				'origUid' => 't3_origuid',
				'languageField' => 'sys_language_uid',
				'transOrigPointerField' => 'l10n_parent',
				'transOrigDiffSourceField' => 'l10n_diffsource',
				// #t4183, 191005, dwildt, 1-/+
//'default_sortby' => 'ORDER BY title ASC',
				'sortby' => 'sorting',
				'delete' => 'deleted',
				'enablecolumns' => [
						'disabled' => 'hidden',
				],
				'iconfile' => ConfigurationUtility::getIconPath( Form::TABLE_NAME . '.svg' ),
//				'type' => 'type',
//				'typeicon_column' => 'type',
//				'typeicon_classes' => \Netzmacher\Xblog\TCA\Ctrl\Icons::TypeIconClasses( Form::TABLE_NAME ),
				'searchFields' => ''
				. 'title,'
		,
		],
		'interface' => [
// #v0466, 210105, dwildt, -
//				'showRecordFieldList' => ''
//				. 'title,'
//		,
		],
		'palettes' => [
				'access' => [
						'showitem' => ''
						. 'hidden,'
				,
				],
				'general' => [
						'showitem' => ''
						. 'title,'
						. 'tx_xblog_element,'
				,
				],
		],
		'types' => [
				'0' => [
						'showitem' => ''
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.formrow,'
						. '  title, tx_xblog_element,'
						. '--div--;LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:div.access,'
						. '  sys_language_uid, l10n_parent, l10n_diffsource, hidden'
				,
				],
		],
		'columns' => [
				'sys_language_uid' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.language',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'foreign_table' => 'sys_language',
								'foreign_table_where' => 'ORDER BY sys_language.title',
								'default' => 0,
								'items' => [
										[ 'LLL:EXT:lang/Resources/Private/Language/locallang_general.xml:LGL.allLanguages', -1 ],
										[ 'LLL:EXT:lang/Resources/Private/Language/locallang_general.xml:LGL.default_value', 0 ]
								],
						],
				],
				't3ver_label' => [
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.versionLabel',
						'config' => [
								'type' => 'input',
								'size' => 30,
								'max' => 255,
						]
				],
				'hidden' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.hidden',
						'config' => [
								'type' => 'check',
						],
				],
				'title' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Form::TABLE_NAME . '.title',
						'config' => [
								'type' => 'input',
								'size' => 30,
								'eval' => 'trim,required',
						],
				],
				'tx_xblog_element' => [
						'exclude' => true,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Form::TABLE_NAME . '.tx_xblog_element',
						'config' => [
								'type' => 'inline',
								'foreign_table' => 'tx_xblog_domain_model_element',
								'foreign_field' => 'tx_xblog_domain_model_form',
								'maxitems' => 4,
								'appearance' => [
										'collapseAll' => 1,
										'expandSingle' => 1,
										'levelLinksPosition' => 'top',
										'showSynchronizationLink' => 1,
										'showPossibleLocalizationRecords' => 1,
										'showAllLocalizationLink' => 1
								],
						],
				],
//				'type' => [
//						'exclude' => 0,
//						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Form::TABLE_NAME . '.type',
//						'config' => [
//								'type' => 'select',
//								'renderType' => 'selectSingle',
//								'items' => [
//										'localtable' => [
//												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:type.localtable',
//												'1' => 'localtable',
//												'2' => 'EXT:xblog/Resources/Public/Icons/Type/localtable.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
//										],
//										'foreigntable' => [
//												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:type.foreigntable',
//												'1' => 'foreigntable',
//												'2' => 'EXT:xblog/Resources/Public/Icons/Type/foreigntable.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
//										],
//								],
//								'default' => 'foreigntable',
//						],
//				],
		],
];

return $formTca;
