<?php

use Netzmacher\Xblog\Domain\Model\Tablelayout;
use Netzmacher\Xblog\Utility\ConfigurationUtility;

$tablelayoutTca = [
		'ctrl' => [
				'title' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME,
				'label' => 'title',
				'tstamp' => 'tstamp',
				'crdate' => 'crdate',
				'cruser_id' => 'cruser_id',
				'dividers2tabs' => true,
				'versioningWS' => true,
				'origUid' => 't3_origuid',
				'languageField' => 'sys_language_uid',
				'transOrigPointerField' => 'l10n_parent',
				'transOrigDiffSourceField' => 'l10n_diffsource',
				'sortby' => 'sorting',
				'delete' => 'deleted',
				'enablecolumns' => [
						'disabled' => 'hidden',
				],
				'iconfile' => ConfigurationUtility::getIconPath( Tablelayout::TABLE_NAME . '.svg' ),
				'type' => 'type',
				'typeicon_column' => 'type',
				'typeicon_classes' => \Netzmacher\Xblog\TCA\Ctrl\Icons::TypeIconClasses( Tablelayout::TABLE_NAME ),
				'searchFields' => ''
				. 'table,field,'
		,
		],
		'palettes' => [
				'localtable' => [
						'showitem' => ''
						. 'title,'
						. 'field,'
						. 'order,'
						. '--linebreak--,'
						. 'dontstriptags,'
						. 'columntype,'
						. 'columnvalue,'
						. '--linebreak--,'
						. 'width,'
						. 'crop,'
						. 'linkToDetail,'
				],
		],
		'types' => [
				'localtable' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:palette.localtable;localtable,'
				],
				// Fallback (same as localtable)
				'0' => [
						'showitem' => ''
						. '--palette--;LLL:EXT:xBlog/Resources/Private/Language/locallang_db.xlf:palette.localtable;localtable,'
				],
		],
		'columns' => [
				'sys_language_uid' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.language',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'foreign_table' => 'sys_language',
								'foreign_table_where' => 'ORDER BY sys_language.title',
								'default' => 0,
								'items' => [
										[ 'LLL:EXT:lang/Resources/Private/Language/locallang_general.xml:LGL.allLanguages', -1 ],
										[ 'LLL:EXT:lang/Resources/Private/Language/locallang_general.xml:LGL.default_value', 0 ]
								],
						],
				],
				't3ver_label' => [
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.versionLabel',
						'config' => [
								'type' => 'input',
								'size' => 30,
								'max' => 255,
						]
				],
				'hidden' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:LGL.hidden',
						'config' => [
								'type' => 'check',
						],
				],
				'columntype' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.columntype',
						'onChange' => 'reload',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
										'default' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.columntype.default',
												'1' => 'default',
										],
										'individual' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.columntype.individual',
												'1' => 'individual',
										],
								],
								'default' => 'default',
						],
				],
				'columnvalue' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.columnvalue',
						'displayCond' => 'FIELD:columntype:=:individual',
						'config' => [
								'items' => [
										'0' => [
												'0' => '',
												'1' => '',
										],
								],
								'type' => 'user',
								'multiple' => 0,
								'renderType' => 'TablelayoutColumnvalue',
						],
				],
				'crop' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.crop',
						'displayCond' => 'FIELD:type:=:localtable',
						'config' => [
								'default' => 40,
								'eval' => 'int,trim,required',
								'size' => 4,
								'type' => 'input',
						],
				],
				'field' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.field',
						'displayCond' => 'FIELD:type:=:localtable',
						'config' => [
								'eval' => 'required',
								'items' => [
										'0' => [
												'0' => '',
												'1' => '',
												'2' => '',
										],
								],
								'type' => 'user',
								'multiple' => 0,
								'renderType' => 'FilterFieldlocaltableElement',
								'parameters' => [
										'displayForeigntables' => 1,
								],
						],
				],
				'linkToDetail' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.linkToDetail',
						'displayCond' => 'FIELD:type:=:localtable',
						'config' => [
								'default' => 1,
								'type' => 'check',
						],
				],
				'order' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.order',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
										'asc' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:sheet_table.selectOrderDirection.asc',
												'1' => 'ASC',
										],
										'desc' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/FlexForms/Base.xlf:sheet_table.selectOrderDirection.desc',
												'1' => 'DESC',
										],
								],
								'default' => 'ASC',
						],
				],
				'table' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.table',
						'displayCond' => 'FIELD:type:=:foreigntable',
						'onChange' => 'reload',
						'config' => [
								'items' => [
										'0' => [
												'0' => '',
												'1' => '',
												'2' => '',
										],
								],
								'type' => 'user',
								'multiple' => 0,
								'renderType' => 'FilterTableElement',
								'eval' => 'required',
						],
				],
				'dontstriptags' => [
						'exclude' => 1,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.dontstriptags',
						'config' => [
								'type' => 'check',
						],
				],
				'title' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.title',
						'config' => [
								'type' => 'input',
								'size' => 30,
								'eval' => 'trim,required',
						],
				],
				'type' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.type',
						'config' => [
								'type' => 'select',
								'renderType' => 'selectSingle',
								'items' => [
										'localtable' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:type.localtable',
												'1' => 'localtable',
												'2' => 'EXT:xblog/Resources/Public/Icons/tx_xblog_domain_model_tablelayout.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
										],
										'foreigntable' => [
												'0' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:type.foreigntable',
												'1' => 'foreigntable',
												'2' => 'EXT:xblog/Resources/Public/Icons/tx_xblog_domain_model_tablelayout.' . \Netzmacher\Xblog\TCA\Columns\Type\Items::Ext(),
										],
								],
								'default' => 'localtable',
						],
				],
				'width' => [
						'exclude' => 0,
						'label' => 'LLL:EXT:xblog/Resources/Private/Language/locallang_db.xlf:' . Tablelayout::TABLE_NAME . '.width',
						'displayCond' => 'FIELD:type:=:localtable',
						'config' => [
								'eval' => 'int',
								'size' => 4,
								'type' => 'input',
						],
				],
		]
];

return $tablelayoutTca;
