-- Root pages with an browser plugin

SELECT DISTINCT
  CONCAT('https://', sys_domain.domainName, '/index.php?id=',  pages.uid) AS 'hiddenRootPages',
  pages.deleted AS p_deleted,
  pages.hidden AS p_hidden,
  pages.endtime AS p_endtime,
  tt_content.uid
FROM
  pages,
  sys_domain,
  tt_content
WHERE
  pages.uid = sys_domain.pid AND sys_domain.redirectTo = '' AND sys_domain.hidden = 0 AND
  pages.uid = tt_content.pid AND tt_content.list_type LIKE "%browser%";


-- All Browser plugins

SELECT
  pages.title AS p_title,
  pages.uid AS p_uid,
  pages.deleted AS p_deleted,
  pages.hidden AS p_hidden,
  tt_content.uid AS c_uid,
  tt_content.hidden AS c_hidden,
  tt_content.deleted AS c_deleted,
  tt_content.header AS c_header,
  tt_content.list_type  AS c_list_type,
  tt_content.pi_flexform
FROM
  tt_content,
  pages
WHERE
  tt_content.list_type LIKE "%browser%" AND
  pages.uid = tt_content.pid
ORDER BY
  pages.pid,
  tt_content.sorting;


-- Browser plugin with a defined uid 

SELECT
  hidden,
  deleted,
  header,
  pages,
  pi_flexform
FROM
  tt_content
WHERE
  uid = 14946;


-- All Browser plugins with defined pages

SELECT 
  pages.uid AS p_uid,
  pages.title AS p_title,
  tt_content.hidden AS c_hidden,
  tt_content.deleted AS c_deleted,
  tt_content.header AS c_header
FROM
  pages,
  tt_content
WHERE
      pages.uid = tt_content.pid 
  AND tt_content.list_type LIKE "%browser%"
  AND 6330 IN (tt_content.pages);


-- All Browser plugins with defined pages and org cal

SELECT 
  pages.uid AS p_uid,
  pages.title AS p_title,
  tt_content.hidden AS c_hidden,
  tt_content.deleted AS c_deleted,
  tt_content.header AS c_header
FROM
  pages,
  tt_content
WHERE
      pages.uid = tt_content.pid 
  AND tt_content.list_type LIKE "%browser%"
  AND (
        tt_content.pi_flexform LIKE "%201%"
    OR  tt_content.pi_flexform LIKE "%209%"
    OR  tt_content.pi_flexform LIKE "%211%"
  )
  AND 6330 IN (tt_content.pages);


-- All References of a known Browser plugin

SELECT 
  pages.uid AS p_uid,
  pages.title AS p_title,
  tt_content.uid AS c_uid,
  tt_content.hidden AS c_hidden,
  tt_content.deleted AS c_deleted,
  tt_content.header AS c_header
FROM
  pages,
  tt_content
WHERE
      pages.uid = tt_content.pid 
  AND tt_content.CType LIKE "shortcut"
  AND "tt_content_17919" IN (tt_content.records);