-- Root pages with an xblog plugin

SELECT DISTINCT
    CONCAT('https://', sys_domain.domainName, '/index.php?id=',  pages.uid) AS 'hiddenRootPages',
    pages.deleted AS p_deleted,
    pages.hidden AS p_hidden,
    pages.endtime AS p_endtime
FROM
    pages,
    sys_domain,
    tt_content
WHERE
    pages.uid = sys_domain.pid AND sys_domain.redirectTo = '' AND sys_domain.hidden = 0 AND
    pages.uid = tt_content.pid AND tt_content.list_type LIKE "%xblog%"


-- All xBlogs

SELECT
  pages.title AS p_title,
  pages.uid AS p_uid,
  pages.deleted AS p_deleted,
  pages.hidden AS p_hidden,
  tt_content.uid AS c_uid,
  tt_content.hidden AS c_hidden,
  tt_content.deleted AS c_deleted,
  tt_content.header AS c_header,
  tt_content.list_type  AS c_list_type
FROM
  pages,
  tt_content
WHERE
      pages.uid = tt_content.pid
  AND tt_content.list_type LIKE "%xblog%"
  AND tt_content.deleted = 0
  AND tt_content.hidden = 0
ORDER BY
  tt_content.list_type,
  pages.uid,
  tt_content.sorting;


-- Statistic xBlogs

SELECT
  tt_content.list_type,
  COUNT(*)
FROM
  tt_content
WHERE
  tt_content.list_type LIKE "%xblog%"
  AND tt_content.deleted = 0
  AND tt_content.hidden = 0
GROUP BY
  tt_content.list_type
ORDER BY
  tt_content.list_type,
  tt_content.uid,
  tt_content.sorting;

user     = debian-sys-maint
password = 5vWNkWNmmuI6u0Kq
-- xBlogs Main (xblog_pi1), Slider (xblog_pi11) and RSS-Feed (xblog_pi13) without a sheet profile

SELECT
    pages.title AS p_title,
    pages.uid AS p_uid,
    pages.deleted AS p_deleted,
    pages.hidden AS p_hidden,
    tt_content.uid AS c_uid,
    tt_content.hidden AS c_hidden,
    tt_content.deleted AS c_deleted,
    tt_content.header AS c_header,
    tt_content.list_type AS c_list_type
FROM
    tt_content,
    pages
WHERE
    list_type IN(
        'xblog_pi1',
        'xblog_pi11',
        'xblog_pi13'
    ) AND pi_flexform NOT LIKE "%<sheet index=\"profile\">%" AND pages.uid = tt_content.pid
ORDER BY
    pages.pid,
    tt_content.sorting


-- Append the profile sheet to xBlog plugins Main (xblog_pi1), Slider (xblog_pi11) and RSS-Feed (xblog_pi13) without a profile sheet

SELECT
    tt_content.pid,
    tt_content.uid,
    tt_content.hidden,
    tt_content.deleted,
    tt_content.header,
    tt_content.list_type,
    tt_content.pi_flexform
FROM
    tt_content
WHERE
    list_type IN(
        'xblog_pi1',
        'xblog_pi11',
        'xblog_pi13'
    ) AND pi_flexform NOT LIKE "%<sheet index=\"profile\">%"
--    AND uid = 39422
ORDER BY
    uid


UPDATE tt_content
SET 
    pi_flexform = REPLACE(pi_flexform,
        '</data>\n<t3FlexForms>',
        '<sheet index="profile">
            <language index="lDEF">
                <field index="settings.flexform.pi1.profile.showUid">
                    <value index="vDEF">newsUid</value>
                </field>
                <field index="settings.flexform.pi1.profile.default.displayitem">
                    <value index="vDEF">subheaderheadertext</value>
                </field>
                <field index="settings.flexform.pi1.profile.default.topitemonly">
                    <value index="vDEF">0</value>
                </field>
                <field index="settings.flexform.pi1.profile.datetimefield">
                    <value index="vDEF">datetime</value>
                </field>
                <field index="settings.flexform.pi1.profile.datetimeformat">
                    <value index="vDEF">ddmmyy</value>
                </field>
                <field index="settings.flexform.pi1.profile.datetimedisplay">
                    <value index="vDEF">default</value>
                </field>
                <field index="settings.flexform.pi1.profile.datetimepositioninlist">
                    <value index="vDEF">default</value>
                </field>
            </language>
        </sheet>
    </data>
<t3FlexForms>')
WHERE
    list_type IN(
        'xblog_pi1',
        'xblog_pi11',
        'xblog_pi13'
    ) AND pi_flexform NOT LIKE "%<sheet index=\"profile\">%"
--    AND uid = 39422


-- Append the socialmedia sheet to xBlog plugin Main (xblog_pi1)) without a socialmedia sheet

SELECT
    tt_content.pid,
    tt_content.uid,
    tt_content.hidden,
    tt_content.deleted,
    tt_content.header,
    tt_content.list_type,
    tt_content.pi_flexform
FROM
    tt_content
WHERE
    list_type IN(
        'xblog_pi1'
    ) AND pi_flexform NOT LIKE "%<sheet index=\"socialmedia\">%"
    AND pi_flexform LIKE '%</data>
<t3FlexForms>'
    AND uid = 39426
ORDER BY
    uid

UPDATE tt_content
SET 
    pi_flexform = REPLACE(pi_flexform,
        '</data>
<t3FlexForms>',
        '  <sheet index="socialmedia">
            <language index="lDEF">
                <field index="settings.flexform.pi1.socialmedia.services">
                    <value index="vDEF"></value>
                </field>
                <field index="settings.flexform.pi1.socialmedia.orientation">
                    <value index="vDEF">horizontal</value>
                </field>
                <field index="settings.flexform.pi1.socialmedia.theme">
                    <value index="vDEF">standard</value>
                </field>
            </language>
        </sheet>
    </data>
<t3FlexForms>')
WHERE
    list_type IN(
        'xblog_pi1'
    ) AND pi_flexform NOT LIKE "%<sheet index=\"socialmedia\">%"
    AND uid = 39426
      


-- xBlogs which match some parameters

SELECT
  pages.uid AS p_uid,
  pages.title AS p_title,
  pages.hidden AS p_hidden,
  pages.deleted AS p_deleted,
  tt_content.uid AS c_uid,
  tt_content.hidden AS c_hidden,
  tt_content.deleted AS c_deleted,
  tt_content.header AS c_header,
  tt_content.list_type AS c_list_type
FROM
    tt_content,
    pages
WHERE
      tt_content.list_type LIKE "%xblog%" 
  AND pages.uid = tt_content.pid
  AND (
    tt_content.pi_flexform LIKE "%46009%" 
--     OR  tt_content.pi_flexform LIKE "%940%" 
--     OR  tt_content.pi_flexform LIKE "%1940%"
  )
ORDER BY
  pages.uid,
  tt_content.uid;

-- pid 111, uid 270
-- pid 257, uid 940
-- pid 937, uid 1940