document.addEventListener('DOMContentLoaded', function () {
	var xblogs = document.getElementsByClassName("xBlogMain");
	Array.from(xblogs).forEach(xBlogBubbles);
}, false);

window.addEventListener('resize', function () {
	var ba = document.getElementsByClassName("xBlogBubble");
	Array.from(ba).forEach(function (b) {
		b.style.visibility = 'hidden';
	}, false);
	var xblogs = document.getElementsByClassName("xBlogMain");
	Array.from(xblogs).forEach(xBlogBubbles);
}, false);

function xBlogBubbles(item, index) {
	if (item.firstChild.classList.contains("xBlogItems") && item.firstChild.firstChild.classList.contains('xBlogBubble')) {
		var can = item.firstChild;
		var da = can.children;
		var id = item.id;
	} else {
		return;
	}
	if (can.offsetHeight < 400) {
		can.style.height = can.offsetWidth * 0.75 + "px";
	}
	can.style.height = can.offsetHeight + "px";
	can.style.height = "500px";
	can.style.position = "relative";
	can.parentElement.parentElement.classList.add("bubbles");

	// Background and text colour for bubbles
	// 201123, dwildt: next three lines will set by MainController::_renderJavascriptXblogBubble()
	//var xBlogBubbleBgColors = ["#00A358", "#FFEE00", "#4CB4E7", "#E6007E", "#D4EDFC"];
	//var xBlogBubbleColors		= ["#FFF", "#00A358", "#FFF", "#FFF", "#4CB4E7"];
	//var xBlogBubbleDistance = -10;			// Distance between circles. Negative value: circles will overlap
	//var xBlogBubbleRadius		= 100;			// Radius coefficient

	var circles = [];
	var circle = {};
	var NumCircles = 10; // Max prepared positions for markup objects
	var protection = 10000; // Do not iterate gentle into that good night.
	var counter = 0;
	var canvasWidth = can.offsetWidth;
	var canvasHeight = can.offsetHeight;

	// Small screens / divs	
	var scale = 1;
	if (canvasWidth < 800)
	{
		scale = canvasWidth / 800
	}

	// Reserved for headline
	var headX = (canvasWidth * scale) / 3;
	var headY = (canvasHeight * scale) / 5;

	// Find possible positions until enough or give up after [protection]
	while (circles.length < NumCircles && counter < protection) {
		circle = {
			r: (Math.random() * 50 + xBlogBubbleRadius) * scale,
			x: (Math.random() * (canvasWidth - 300 * scale)),
			y: (Math.random() * (canvasHeight - 300 * scale)),
		};

		overlapping = false;

		// Leave space for headline
		if (circle.x < headX && circle.y < headY)
			overlapping = true;

		for (var i = 0; i < circles.length; i++) {
			var existing = circles[i];
			var a = circle.x - existing.x;
			var b = circle.y - existing.y;
			var d = Math.sqrt(a * a + b * b);
			if (d < circle.r + existing.r + xBlogBubbleDistance) {
				overlapping = true;
				// do not add to array
				break;
			}
		}

		// add valid circles to array
		if (!overlapping) {
			circles.push(circle);
		}
		counter++;
	}

	for (var i = 0; i < da.length && i < circles.length; i++) {
		var d = da[i];
		var c = d.getElementsByClassName("circle")[0];
		var h = d.getElementsByTagName("H2")[0];
		var a = h.getElementsByTagName("a")[0];
		var u = d.getElementsByTagName("H3")[0];
		var p = d.getElementsByTagName("p")[0];

		d.style.position = "absolute";
		d.style.left = circles[i].x + 'px';
		d.style.top = circles[i].y + 'px';
		d.style.width = 2 * circles[i].r + 'px';
		d.style.height = 2 * circles[i].r + 'px';
		c.style.background = xBlogBubbleBgColors[i % 6]; // upto 6 colors
		c.style.border = "3px solid " + xBlogBubbleBgColors[i % 6]; // upto 6 colors

		if (a)
		{
			a.style.color = xBlogBubbleColors[i % 6]; // upto 6 colors
		}
		if (u)
		{
			u.style.color = xBlogBubbleColors[i % 6];	// upto 6 colors
		}
//		if (h)
//		{
//			h.style.fontSize = (circles[i].r - 10) / 1.5 + '%';
//		}
//		if (u)
//		{
//			u.style.fontSize = (circles[i].r - 10) / 1.9 + '%';
//		}
//		if (p)
//		{
//			p.style.fontSize = (circles[i].r - 10) / 2.1 + '%';
//		}
// #v0607, 200109, dwildt
		if (h)
		{
			h.style.fontSize = ((circles[i].r - 10) / 100) * 1.8 + 'em';
		}
		if (u)
		{
			u.style.fontSize = ((circles[i].r - 10) / 100 * 1.6) + 'em';
		}
		if (p)
		{
			p.style.fontSize = ((circles[i].r - 10) / 100 * 1.2) + 'em';
		}

		d.style.visibility = "visible";
	}
}
